<script lang="ts">
  import { onMount, onDestroy } from 'svelte';
  import { Tooltip } from 'sveltestrap';

  export let id: string;
  export let placement = 'bottom';
  export let hovertext: string;
  export let endtime: Date;
  export let size = 15;
  const size1 = `${Math.floor(size * (1 / 3))}px`;
  const size2 = `${Math.floor(size * (2 / 3))}px`;
  const size3 = `${Math.floor(size)}px`;
  let interval: NodeJS.Timer;
  let time;
  // Display times
  const total = 0;
  let days = Math.random() % 10;
  let hours = Math.random() % 10;
  let minutes = Math.random() % 10;
  let seconds = Math.random() % 10;

  onMount(async () => {
    function updateClock() {
      const t = getTimeRemaining(endtime);

      days = t.days;
      hours = t.hours;
      minutes = t.minutes;
      seconds = t.seconds;

      if (t.total <= 0) {
        days = 0;
        hours = 0;
        minutes = 0;
        seconds = 0;
        clearInterval(interval);
      }
    }

    updateClock();
    interval = setInterval(updateClock, 1000);
  });

  onDestroy(() => {
    clearInterval(interval);
  });

  function getTimeRemaining(endtime) {
    const t = Date.parse(endtime) - Date.now();
    return {
      total: t,
      days: Math.floor(t / (1000 * 60 * 60 * 24)),
      hours: Math.floor((t / (1000 * 60 * 60)) % 24),
      minutes: Math.floor((t / 1000 / 60) % 60),
      seconds: Math.floor((t / 1000) % 60),
    };
  }
</script>

<div {id} class="countdown" style="--size1: {size1};--size2: {size2};--size3: {size3}">
  <Tooltip target={id} {placement}>{hovertext}</Tooltip>
  {#if days > 0}
    <div>
      <div>{String(days).padStart(2, '0')}</div>
      <div>Days</div>
    </div>
  {/if}
  {#if hours > 0}
    <div>
      <div>{String(hours).padStart(2, '0')}</div>
      <div>Hours</div>
    </div>
  {/if}
  <div>
    <div>{String(minutes).padStart(2, '0')}</div>
    <div>Minutes</div>
  </div>
  <div>
    <div>{String(seconds).padStart(2, '0')}</div>
    <div>Seconds</div>
  </div>
</div>

<style>
  * {
    color: #eee;
    text-align: center;
    font-weight: 100;
    font-family: sans-serif;
  }
  .countdown {
    display: flex;
    justify-content: center;
    align-items: center;
    flex-wrap: nowrap;
  }
  .countdown > div {
    padding: var(--size2);
    margin: var(--size1);
    background: #1e1e1e;
  }
  .countdown div > div:first-child {
    padding: var(--size3);
    background: #0a0a0a;
  }
  .countdown div > div:nth-child(2) {
    padding-top: var(--size1);
    font-size: var(--size3);
  }
</style>
